{--------------------------------------------------------------------}
{ mwFastTime V 1.3                                                   }
{ Written by Martin Waldenburg 1996.                                 }
{ Copyright by Martin Waldenburg 1996. All rights reserved.          }
{ This is FreeWare.                                                  }
{ It's provided as is, without a warranty of any kind.               }
{ You use it at your own risc.                                       }
{ You may use and distribute it freely.                              }
{ But You may not say it's your work                                 }
{ If you distribute it you must provide all Files.                   }
{ Thanks to Primoz Gabrijelcic                                       }
{--------------------------------------------------------------------}

{$UNDEF D4PLUS}
{$IFDEF VER120}{$DEFINE D4PLUS}{$ENDIF}
{$IFDEF VER130}{$DEFINE D4PLUS}{$ENDIF}

unit mwFastTime;

interface

uses
  SysUtils, Windows, Classes;

type
  TmwFastTime = class(TComponent)
  private
    Frequency, StartValue, StopValue: TLargeInteger;
    function GetElapsedTime: ShortString;
    function GetElapsed: Extended;
  protected
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    Property Elapsed: Extended read GetElapsed;
    Property ElapsedTime: ShortString read GetElapsedTime;
    Procedure Start;
    Procedure Stop;
  published
    Property Name;
    Property Tag;
  end;

procedure Register;


implementation

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

procedure Register;
begin
  RegisterComponents('mw', [TmwFastTime]);
end;


{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

constructor TmwFastTime.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  QueryPerformanceFrequency(Frequency);
end;


{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

destructor TmwFastTime.Destroy;
begin
  inherited Destroy;
end;


{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

function TmwFastTime.GetElapsed: Extended;
begin
{$IFDEF D4PLUS}
  Result := (StopValue-StartValue)/Frequency;
{$ELSE}
  Result:= (StopValue.QuadPart - StartValue.QuadPart) / Frequency.QuadPart;
{$ENDIF}
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

function TmwFastTime.GetElapsedTime: ShortString;
begin
  Result := format('Seconds: %g', [GetElapsed]);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

Procedure TmwFastTime.Start;
begin
  QueryPerformanceCounter(StartValue);
end;


{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

Procedure TmwFastTime.Stop;
begin
  QueryPerformanceCounter(StopValue);
end;

end.

